unit FirstArg;
{$I DFS.inc}{ Copyright (C) 2005 C M Western; see UCompat.pas for license}
interface

{ Essentially Paramstr(1), but tries to take account of
  blanks in file names under MS Windows, assuming only one file is expected
  on the command line }

function GetFirstFileArg: string;

implementation

{$IFDEF UNIX}
function GetFirstFileArg: string;
begin
  Result := ParamStr(1);
end;
{$ENDIF}

{$IFDEF MSWINDOWS}
uses SysUtils, Windows;

function GetFirstFileArg: string;
var
  P: PChar;
  procedure SkipSpaces(var P: PChar);
  begin
    while (P[0] <> #0) and (P[0] <= ' ') do Inc(P);
  end;
  procedure SkipArg(var P: PChar);
  begin
    SkipSpaces(P);
    if P[0] = '"' then begin
      Inc(P);
      while (P[0] <> #0) and (P[0] <> '"') do Inc(P);
      if P[0] = '"' then Inc(P);
    end else
      while (P[0] <> #0) and (P[0] > ' ') do Inc(P);
  end;
begin
  if ParamCount = 0 then
    Result := ''
  else begin
    Result := ParamStr(1);
    if ParamCount > 1 then begin
      P := GetCommandLine;
      SkipArg(P);
      SkipSpaces(P);
      if P[0] = '"' then Exit; { Already in quotes, so should be OK }
      Result := P;
      Result := Trim(Result);
    end;
  end;
end;
{$ENDIF}

end.
