unit LogBase;

interface
{$I DFS.inc}{ Copyright (C) 2005 C M Western; see PcontrolsReg.pas for license}
uses
  {$IFDEF MSWINDOWS} Windows, {$ENDIF}
  {$IFDEF LCL_} LCLType, {$ENDIF}
  {$IFNDEF CLX_} Menus, ImgList, ActnList, Messages, Graphics, Forms, Controls, StdCtrls,
  {$ELSE} QActnList, QImgList, QGraphics, QMenus, QForms, QControls, QStdCtrls, Qt, QTypes, Types, {$ENDIF}
  Classes, LogActn, ExActn, Log;

type
  TLogBaseChild = class(TForm)
    ActionList: TActionList;
    MainMenu: TMainMenu;
    EditItem: TMenuItem;
    Cut: TMenuItem;
    CopyItem: TMenuItem;
    Delete: TMenuItem;
    SelectAllItem: TMenuItem;
    N3: TMenuItem;
    Find: TMenuItem;
    FindNext: TMenuItem;
    FindthisWordItem: TMenuItem;
    ExSelectAll: TExSelectAll;
    LogFind: TLogFind;
    LogFindNext: TLogFindNext;
    LogFindThisWord: TLogFindThisWord;
    TextGoToLine: TTextGoToLine;
    GoToLine: TMenuItem;
    N1: TMenuItem;
    ExClear: TExClear;
    ExCopy: TExCopy;
    ExCut: TExCut;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
  private
    FLog: TLog;
    procedure SetLog(const Value: TLog);
    {$IFDEF MSWINDOWS}
    procedure WMMouseActivate(var Message: TMessage); message WM_MOUSEACTIVATE;
    {$ENDIF}
  protected
    procedure Activate; override;
    {$IFDEF MSWINDOWS}
    procedure CreateParams(var Params: TCreateParams); override;
    {$ENDIF}
  public
    constructor Create(AOwner: TComponent); override;
  property
    Log: TLog read FLog write SetLog;
  end;

var
  LogBaseChild: TLogBaseChild;

implementation

uses ImageMod;

{$IFNDEF LCL_}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

procedure TLogBaseChild.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  CloseAction := caFree;
end;

procedure TLogBaseChild.SetLog(const Value: TLog);
begin
  Flog := Value;
end;

{$IFDEF LINUX}
{ May need:
    if MainMenu <> nil then
      MainMenu.AutoMerge := False;
}
{$ENDIF}

procedure TLogBaseChild.Activate;
begin
  {$IFDEF MSWINDOWS}
  { MDI bug fix }
  SetWindowLong(Handle, GWL_STYLE,
                GetWindowLong(Handle, GWL_STYLE) or WS_SYSMENU);
  {$ENDIF}
  inherited;
end;

{$IFDEF MSWINDOWS}
procedure TLogBaseChild.CreateParams(var Params: TCreateParams);
begin
  { LogBaseChild is fsMDIChild, but derived types may be fsNormal; should be overwritten
    on loading resorce, but seems to create window before loading finished }
  if (FormStyle = fsMDIChild) and not (csDesigning in ComponentState)
     and ( (Application.MainForm = nil) or (Application.MainForm.ClientHandle = 0) ) then begin
    FormStyle := fsNormal;
    {$IFDEF VCL_}
    MainMenu.AutoMerge := False;
    {$ENDIF}
  end;
  inherited;
end;

procedure TLogBaseChild.WMMouseActivate(var Message: TMessage);
begin
  { MDI bug fix }
  if FormStyle = fsMDIChild then
    {$IFDEF WIN32}Windows{$ELSE}WinProcs{$ENDIF}.SetFocus(Handle);
  inherited;
end;
{$ENDIF}

constructor TLogBaseChild.Create(AOwner: TComponent);
begin
  Position := poDefault;
  inherited Create(AOwner);
  {$IFDEF LCL_}
  if Assigned(ImageModule) then
    MainMenu.Images := ImageModule.ImageList;
  {$ENDIF}
end;

end.
